{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, Japanese character code conversion}
unit Kanji;

interface

uses WinTypes, TTTypes;


function  SJIS2JIS(KCode: word): word;
function  SJIS2EUC(KCode: word): word;
function  JIS2SJIS(KCode: word): word;

implementation

function SJIS2JIS(KCode: word): word;
var
  x0,x1,x2,y0: word;
begin
  case Lo(KCode) of
    $40..$7f:
      begin
        x0 := $8140;
        y0 := $2121;
      end;
    $80..$9e:
      begin
        x0 := $8180;
        y0 := $2160;
      end;
    else
      begin
        x0 := $819f;
        y0 := $2221;
      end;
  end;
  if Hi(KCode) >= $e0 then
  begin
    x0 := x0 + $5f00;
    y0 := y0 + $3e00;
  end;
  x1 := (KCode-x0) div $100;
  x2 := (KCode-x0) mod $100;
  SJIS2JIS := y0 + x1*$200 + x2;
end;

function SJIS2EUC(KCode: word): word;
begin
  SJIS2EUC := SJIS2JIS(KCode) or $8080;
end;

function JIS2SJIS(KCode: word): word;
var
  n1,n2, SJIS: word;
begin
  n1 := (KCode-$2121) div $200;
  n2 := (KCode-$2121) mod $200;

  case n1 of
    0..$1e: SJIS := $8100 + n1*256;
    else    SJIS := $C100 + n1*256;
  end;
  case n2 of
    0..$3e:    JIS2SJIS := SJIS + n2 + $40;
    $3f..$5d: JIS2SJIS := SJIS + n2 + $41;
    else       JIS2SJIS := SJIS + n2 - $61;
  end;
end;

end.