{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTCMN.DLL, winsock interface
 PASCAL version of winsock.h}

{Origin of this file is:

  Winsock.h file for Borland Pascal
  Conversion by Marc B. Manza
             Center for Applied Large-Scale Computing
  Requires Winsock.pas and Winsock.inc

  Send any comments/change requests/etc. to:
  manza@flash.poly.edu }

unit WinsockH;

interface

uses WinTypes;

type
  u_char = char;
  u_short = word;
  u_int = word;
  u_long = longint;

  SOCKET = u_int;

const
     FD_SETSIZE     =   64;
type
    Pfd_set = ^Tfd_set;
    Tfd_set = record
      fd_count : u_short;
      fd_array : array[0..FD_SETSIZE-1] of SOCKET;
    end;

    Ptimeval = ^timeval;
    timeval = record
      tv_sec, tv_usec : longint;
    end;

type
  phostent = ^hostent;
  hostent = record
              h_name: PChar;
              h_aliases: ^PChar;
              h_addrtype: integer;
              h_length: integer;
              h_addr_list: ^PChar;
              h_addr: PChar;
            end;

const
  IPPROTO_IP     =   0;
  IPPROTO_TCP    =   6;

const
  IPPORT_TELNET  =   23;


type
  in_addr = record
              S_addr : u_long;
            end;
type
  sockaddr_in = record
    sin_family : integer;
    sin_port : u_short;
    sin_addr : in_addr;
    sin_zero : array[0..7] of char;
  end;

const
  WSADESCRIPTION_LEN = 256;
  WSASYS_STATUS_LEN = 128;

type
  LPWSADATA = ^WSAData;
  WSAData = record
    wVersion: word;
    wHighVersion: word;
    szDescription: array[0..WSADESCRIPTION_LEN] of char;
    szSystemStatus: array[0..WSASYS_STATUS_LEN] of char;
    iMaxSockets: word;
    iMaxUdpDg: word;
    lpVendorInfo: PChar;
  end;

const
  INVALID_SOCKET = $FFFF;
  SOCKET_ERROR = -1;

  SOCK_STREAM = 1;

const
  SO_DEBUG       =   $0001;
  SO_ACCEPTCONN  =   $0002;
  SO_REUSEADDR   =   $0004;
  SO_KEEPALIVE   =   $0008;
  SO_DONTROUTE   =   $0010;
  SO_BROADCAST   =   $0020;
  SO_USELOOPBACK =   $0040;
  SO_LINGER      =   $0080;
  SO_OOBINLINE   =   $0100;

  SO_DONTLINGER  =   $ff7f;

  SO_SNDBUF      =   $1001;
  SO_RCVBUF      =   $1002;
  SO_SNDLOWAT    =   $1003;
  SO_RCVLOWAT    =   $1004;
  SO_SNDTIMEO    =   $1005;
  SO_RCVTIMEO    =   $1006;
  SO_ERROR       =   $1007;
  SO_TYPE        =   $1008;

const
  AF_INET = 2;

type
  sockaddr = record
               sa_family: u_short;
               sa_data: array[0..13] of char;
             end;

const
  PF_INET = AF_INET;

const
  MAXGETHOSTSTRUCT = 1024;

const
  SOL_SOCKET = -1;
  MSG_OOB    = $01;

const
  FD_READ    = $01;
  FD_WRITE   = $02;
  FD_OOB     = $04;
  FD_ACCEPT  = $08;
  FD_CONNECT = $10;
  FD_CLOSE   = $20;

  WSABASEERR         =  10000;

  WSAEINTR           =  (WSABASEERR + 4);
  WSAEBADF           =  (WSABASEERR + 9);
  WSAEFAULT          =  (WSABASEERR + 14);
  WSAEINVAL          =  (WSABASEERR + 22);
  WSAEMFILE          =  (WSABASEERR + 24);

  WSAEWOULDBLOCK     =  (WSABASEERR + 35);
  WSAEINPROGRESS     =  (WSABASEERR + 36);
  WSAEALREADY        =  (WSABASEERR + 37);
  WSAENOTSOCK        =  (WSABASEERR + 38);
  WSAEDESTADDRREQ    =  (WSABASEERR + 39);
  WSAEMSGSIZE        =  (WSABASEERR + 40);
  WSAEPROTOTYPE      =  (WSABASEERR + 41);
  WSAENOPROTOOPT     =  (WSABASEERR + 42);
  WSAEPROTONOSUPPORT =  (WSABASEERR + 43);
  WSAESOCKTNOSUPPORT =  (WSABASEERR + 44);
  WSAEOPNOTSUPP      =  (WSABASEERR + 45);
  WSAEPFNOSUPPORT    =  (WSABASEERR + 46);
  WSAEAFNOSUPPORT    =  (WSABASEERR + 47);
  WSAEADDRINUSE      =  (WSABASEERR + 48);
  WSAEADDRNOTAVAIL   =  (WSABASEERR + 49);
  WSAENETDOWN        =  (WSABASEERR + 50);
  WSAENETUNREACH     =  (WSABASEERR + 51);
  WSAENETRESET       =  (WSABASEERR + 52);
  WSAECONNABORTED    =  (WSABASEERR + 53);
  WSAECONNRESET      =  (WSABASEERR + 54);
  WSAENOBUFS         =  (WSABASEERR + 55);
  WSAEISCONN         =  (WSABASEERR + 56);
  WSAENOTCONN        =  (WSABASEERR + 57);
  WSAESHUTDOWN       =  (WSABASEERR + 58);
  WSAETOOMANYREFS    =  (WSABASEERR + 59);
  WSAETIMEDOUT       =  (WSABASEERR + 60);
  WSAECONNREFUSED    =  (WSABASEERR + 61);
  WSAELOOP           =  (WSABASEERR + 62);
  WSAENAMETOOLONG    =  (WSABASEERR + 63);
  WSAEHOSTDOWN       =  (WSABASEERR + 64);
  WSAEHOSTUNREACH    =  (WSABASEERR + 65);
  WSAENOTEMPTY       =  (WSABASEERR + 66);
  WSAEPROCLIM        =  (WSABASEERR + 67);
  WSAEUSERS          =  (WSABASEERR + 68);
  WSAEDQUOT          =  (WSABASEERR + 69);
  WSAESTALE          =  (WSABASEERR + 70);
  WSAEREMOTE         =  (WSABASEERR + 71);

  WSASYSNOTREADY     =  (WSABASEERR + 91);
  WSAVERNOTSUPPORTED =  (WSABASEERR + 92);
  WSANOTINITIALISED  =  (WSABASEERR + 93);

  FIONBIO = $8004667E;
  SIOCATMARK = $40047307;

implementation
end.